/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.ai.BattleAIManager
 *  fire.pb.battle.operate.AiOperate
 *  fire.pb.battle.operate.DecisionOperate
 *  fire.pb.battle.operate.FighterOperate
 *  fire.pb.battle.operate.Operate
 *  fire.pb.skill.Module
 *  fire.pb.skill.fight.FightSkillConfig
 *  xbean.BattleInfo
 *  xbean.Decision
 */
package fire.pb.battle;

import fire.pb.battle.AIOperation;
import fire.pb.battle.DecisionProcesser;
import fire.pb.battle.DemoResult;
import fire.pb.battle.Fighter;
import fire.pb.battle.ResultItem;
import fire.pb.battle.SubResultItem;
import fire.pb.battle.ai.BattleAIManager;
import fire.pb.battle.operate.AiOperate;
import fire.pb.battle.operate.DecisionOperate;
import fire.pb.battle.operate.FighterOperate;
import fire.pb.battle.operate.Operate;
import fire.pb.skill.Module;
import fire.pb.skill.fight.FightSkillConfig;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import xbean.BattleInfo;
import xbean.Decision;

public class BattleSequenceHelper {
    public static LinkedList<AIOperation> processAIActionWhileRoundStart(BattleInfo battle, List<Operate> sequence) {
        ArrayList extacts = new ArrayList();
        LinkedList clientActions = BattleAIManager.getInstance().getActionWhileRoundStart(battle, extacts);
        for (int i = extacts.size() - 1; i >= 0; --i) {
            Operate act = (Operate)extacts.get(i);
            sequence.add(0, act);
        }
        extacts.clear();
        clientActions.addAll(BattleAIManager.getInstance().getRoleActionWhileRoundStart(battle, extacts));
        ArrayList<Integer> roleids = new ArrayList<Integer>();
        for (int i = 0; i < extacts.size(); ++i) {
            Decision decision;
            AiOperate act = (AiOperate)extacts.get(i);
            if (roleids.contains(act.getFighter().getFighterId())) continue;
            if (act.getFighter().isRole() && (decision = (Decision)battle.getDecisions().get(act.getFighter().getFighterId())) != null) {
                if (!decision.getIsauto()) continue;
                if (act.getAiAct().getOperationType() == 2 || act.getAiAct().getOperationType() == 1) {
                    FightSkillConfig battleSkillConfig = Module.getInstance().getFightSkillConfig(act.getAiAct().getOperationId());
                    if (battleSkillConfig == null) {
                        Module.logger.error((Object)("ERROR: Battle Skill is not exist. skillId = " + act.getAiAct().getOperationId()));
                        throw new IllegalArgumentException("ERROR: Battle Skill is not exist. skillId = " + act.getAiAct().getOperationId());
                    }
                    if (!DecisionProcesser.checkMonsterHpMpConsume(battleSkillConfig, battle, act.getFighter())) continue;
                    if (decision.getIsauto() && decision.getOperatetype() == 4) {
                        battle.getDecisions().remove(act.getFighter().getFighterId(), decision);
                    }
                }
            }
            boolean isinsert = false;
            ListIterator<Operate> lit = sequence.listIterator();
            while (lit.hasNext()) {
                Operate opt = lit.next();
                if (((FighterOperate)opt).getFighter().getFighterId() != act.getFighter().getFighterId()) continue;
                isinsert = true;
                if (lit.hasPrevious()) {
                    lit.previous();
                }
                lit.add((Operate)act);
                roleids.add(act.getFighter().getFighterId());
                break;
            }
            if (isinsert) continue;
            sequence.add(0, (Operate)act);
        }
        return clientActions;
    }

    public static List<AIOperation> processAIActionBeforeOperation(BattleInfo battle, ListIterator<Operate> lit, List<AiOperate> extActs, int actcount, Fighter curfighter) {
        LinkedList clientActions = BattleAIManager.getInstance().getActionBeforeOperation(battle, extActs, actcount, curfighter);
        return clientActions;
    }

    public static List<AIOperation> processAIActionRoundEnd(BattleInfo battle, ListIterator<Operate> lit, int actcount) {
        ArrayList extActs = new ArrayList();
        LinkedList<AIOperation> clientActions = new LinkedList<AIOperation>();
        clientActions.addAll(BattleAIManager.getInstance().getActionRoundEnd(battle, extActs, actcount, battle.getFieldfighter()));
        for (Fighter fighter : battle.getFighterobjects().values()) {
            ArrayList extActs2 = new ArrayList();
            if (fighter.getAiagent() == null || fighter.getFightertype() == 1) continue;
            clientActions.addAll(BattleAIManager.getInstance().getActionRoundEnd(battle, extActs2, actcount, fighter));
            if (extActs2.size() > 1) {
                ListIterator litopt = extActs2.listIterator();
                AiOperate root = null;
                while (litopt.hasNext()) {
                    AiOperate opt = (AiOperate)litopt.next();
                    if (opt.getAiAct().getOperationType() != 12) continue;
                    if (root == null) {
                        root = opt;
                        continue;
                    }
                    root.getAiAct().getSummonMaps().putAll(opt.getAiAct().getSummonMaps());
                    litopt.remove();
                }
            }
            if (extActs2.size() <= 0) continue;
            BattleSequenceHelper.insertExtraActs(battle, lit, fighter, extActs2);
        }
        return clientActions;
    }

    public static List<AIOperation> processAIActionsForDefendAndProtect(List<ResultItem> script, List<AIOperation> beforeAIActions) {
        if (script.size() != 0) {
            for (AIOperation aiaction : beforeAIActions) {
                --aiaction.actionseq;
                aiaction.actionmoment = -1;
            }
        }
        return beforeAIActions;
    }

    public static List<AIOperation> processAIActionAfterOperation(BattleInfo battle, ListIterator<Operate> lit, int actcount, ResultItem lastResult) {
        Fighter curfighter = null;
        curfighter = lastResult.execute.attackerid == 0 ? battle.getFieldfighter() : (Fighter)battle.getFighterobjects().get(lastResult.execute.attackerid);
        if (actcount == -1 || curfighter == null) {
            return new LinkedList<AIOperation>();
        }
        ArrayList extActs = new ArrayList();
        List clientActions = BattleAIManager.getInstance().getActionAfterOperation(battle, extActs, actcount, lastResult);
        BattleSequenceHelper.insertExtraActs(battle, lit, curfighter, extActs);
        return clientActions;
    }

    public static void processRelive(BattleInfo battle, ListIterator<Operate> lit, ResultItem lastResult) {
        ArrayList<DecisionOperate> extActs = new ArrayList<DecisionOperate>();
        Fighter curfighter = (Fighter)battle.getFighterobjects().get(lastResult.execute.attackerid);
        if (curfighter == null) {
            return;
        }
        for (SubResultItem subresult : lastResult.subresultlist) {
            for (DemoResult demo : subresult.resultlist) {
                Decision decision;
                Fighter relivefighter;
                if ((demo.targetresult & 0x10000) == 0 || !battle.getSkipeddeadfighters().contains(demo.targetid) || (relivefighter = (Fighter)battle.getFighterobjects().get(demo.targetid)) == null || (decision = (Decision)battle.getDecisions().get(demo.targetid)) == null) continue;
                extActs.add(new DecisionOperate(relivefighter, decision));
                battle.getSkipeddeadfighters().remove(demo.targetid);
            }
        }
        BattleSequenceHelper.insertExtraActs(battle, lit, curfighter, extActs);
    }

    public static void insertExtraActs(BattleInfo battle, ListIterator<Operate> lit, Fighter curfighter, List<? extends Operate> extActs) {
        if (curfighter == null) {
            return;
        }
        if (extActs.isEmpty()) {
            return;
        }
        int movecount = 0;
        if (lit.hasPrevious()) {
            while (lit.hasNext()) {
                Operate act = lit.next();
                if (!(act instanceof FighterOperate) || ((FighterOperate)act).getFighter().getFighterId() != curfighter.getFighterId()) {
                    lit.previous();
                    break;
                }
                ++movecount;
            }
        }
        for (Operate operate : extActs) {
            lit.add(operate);
            ++movecount;
        }
        for (int i = 0; i < movecount; ++i) {
            lit.previous();
        }
    }
}

